<?php
/*
Plugin Name: physical2virtual
Version: 2.6.c
Description: Autoconvert physical albums to virtual
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=730
Author: JanisV
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('PHYSICAL2VIRTUAL_ID',       basename(dirname(__FILE__)));
define('PHYSICAL2VIRTUAL_PATH' ,    PHPWG_PLUGINS_PATH . PHYSICAL2VIRTUAL_ID . '/');
define('PHYSICAL2VIRTUAL_ADMIN',    get_root_url() . 'admin.php?page=plugin-' . PHYSICAL2VIRTUAL_ID);

add_event_handler('init', 'physical2virtual_init');
if (defined('IN_ADMIN'))
{
  add_event_handler('get_admin_plugin_menu_links', 'physical2virtual_admin_menu');
} 

function physical2virtual_init()
{
  global $conf;
  
  load_language('plugin.lang', PHYSICAL2VIRTUAL_PATH);

  $conf['physical2virtual'] = unserialize($conf['physical2virtual']);

//  add_event_handler('invalidate_user_cache', 'physical2virtual_convert');
}

function find_or_create_virtual_category($category_name, $parent_id=null, $options=array())
{
  // process empty album name
  if (preg_match('/^\s*$/', $category_name))
  {
    $category_name = '_';
  }

  if (!is_null($parent_id))
  {
    $sub_ids = get_subcat_ids(array($parent_id));
    foreach ($sub_ids as $id)
    {
      $cat_info = get_cat_info($id);
      if ($cat_info['name'] == $category_name and !$cat_info['dir'])
        return $cat_info;
    }
  }

  return create_virtual_category($category_name, $parent_id, $options);
}

function physical2virtual_convert()
{
  global $conf;

  $query = '
    SELECT id, name, id_uppercat
    FROM '.CATEGORIES_TABLE.'
    WHERE dir IS NOT NULL
  ;';  // get physical
  $result = pwg_query($query);
  while ($row = pwg_db_fetch_assoc($result))
  {
    $virt_name = $row['name'];

    $parent = isset($conf['physical2virtual']['parent_cat']) ? $conf['physical2virtual']['parent_cat'] : null;
        
    if ($conf['physical2virtual']['store_structure'])
    {
      // get array of physical parents
      $cat_info = get_cat_info($row['id']);
      $uppers = $cat_info['upper_names'];
      array_pop($uppers); // remove themself
      
      foreach ($uppers as $upper)
      {
        $parent = find_or_create_virtual_category($upper['name'], $parent)['id'];
      }
    }

    $virt_cat = find_or_create_virtual_category($virt_name, $parent);
//    $virt_cat = create_virtual_category($virt_name, $parent)['id']; // use this for duplicate folders name

    if (isset($conf['physical2virtual']['lock_physical']) and $conf['physical2virtual']['lock_physical'])
    {
      $cat_info = get_cat_info($row['id']);
      if ($cat_info['visible'] == true)
      {
        set_cat_visible(array($row['id']), false);
      }
    }
    if (isset($conf['physical2virtual']['private_physical']) and $conf['physical2virtual']['private_physical'])
    {
      set_cat_status(array($row['id']), 'private'); 
    }

    $query = '
      INSERT IGNORE INTO '.IMAGE_CATEGORY_TABLE.' (category_id, image_id)
        SELECT '.$virt_cat['id'].', image_id FROM '.IMAGE_CATEGORY_TABLE.' WHERE category_id = '.$row['id'].'
    ;';
    pwg_query($query);

    if (!(isset($virt_cat['representative_picture_id']) and $virt_cat['representative_picture_id']))
    {
      set_random_representant(array($virt_cat['id']));
    }
  }
}

function physical2virtual_admin_menu($menu)
{
  $menu[] = array(
    'NAME' => 'physical2virtual',
    'URL'  => PHYSICAL2VIRTUAL_ADMIN,
  );

  return $menu;
}

?>
